/* This is a simple helper to enable and disable profiling in Linux.  It's
 * only used manually while profiling, to selectively profile some parts
 * of the code without having gmon.out be polluted by lots of other stuff. */

#include "global.h"
#include <sys/time.h>

static itimerval g_EnableProfiling;
static itimerval g_DisableProfiling; /* 0 */
static void InitProfiling()
{
	static bool bInitialized = false;
	if( bInitialized )
		return;
	bInitialized = true;

	getitimer( ITIMER_PROF, &g_EnableProfiling );
}

void EnableProfiling()
{
	InitProfiling();

	setitimer( ITIMER_PROF, &g_EnableProfiling, NULL );
}

void DisableProfiling()
{
	InitProfiling();

	setitimer( ITIMER_PROF, &g_DisableProfiling, NULL );
}

